#include <stdlib.h>
#include <stdio.h>
#include <time.h>

/*1MB size struct*/
typedef struct bigstruct
{
	char data [1000000];
} bigstruct ;


void call_by_value (bigstruct big)
{
	/*Do something with big*/
}

void call_by_reference (bigstruct* bigptr)
{
	/*Do something with bigptr*/
}

int main(int argc, char* argv[])
{
	/*Parameters*/
	if(argc != 2)
	{
		printf("Wrong Arguments!\n[1]callcount\n");
		return -1;
	}
	int callcount = atoi(argv[1]);


	/*speed comparison*/
	bigstruct big;
	clock_t time;
	
	
	/*Call By Value:*/
	time = clock();
	for(int i = 0; i < callcount; ++i)
	{
		call_by_value(big);
	}
	time = clock() - time;
	printf("value: %f\n", ((float)time)/CLOCKS_PER_SEC);
	
	
	/*Call By Reference:*/
	time = clock();
	for(int i = 0; i < callcount; ++i)
	{
		call_by_reference(&big);
	}
	time = clock() - time;
	printf("reference: %f\n", ((float)time)/CLOCKS_PER_SEC);
	
	
	return 0;
}