#include <stdlib.h>
#include <stdio.h>
#include <time.h>

/*1MB size struct:*/
struct bigstruct
{
	char data[1000000];
};


int main(int argc, char* argv[])
{
	/*Params*/
	if(argc != 3 || atoi(argv[1]) <= 1)
	{
		printf("Wrong Arguments!\n[1]Arraysize > 1\n[2]Swapcount\n");
		return -1;
	}
	
	/*Initialization*/
	int length = atoi(argv[1]);
	printf("arraysize: %d Mb\n", length);
	int swapcount = atoi(argv[2]);
	printf("Swapcount: %d\n", swapcount);
	struct bigstruct* array = malloc(sizeof(struct bigstruct) * length);
	struct bigstruct** ptrarray = malloc(sizeof(struct bigstruct*) * length);
	
	
	for(int i = 0; i < length; ++i)
	{
		for(int j = 0; j < 1000000; ++j)
		{
				array[i].data[j] = rand() % 255;
		}
	}
				
	for(int i = 0; i < length; ++i)
	{
		for(int j = 0; j < 1000000; ++j)
		{
				ptrarray[i] = &array[i];
		}
	}
	
	
	
	/*
	Performance Test
	Swap Positions of two randomly chosen Elements in the array 
	*/
	
	struct bigstruct tmp;
	struct bigstruct* tmpptr = NULL;
	clock_t time;
	int index1;
	int index2;
	
	/*Copy*/
	time = clock();
	for(int i = 0; i < swapcount; ++i)
	{
		index1 = rand() % (length/2);
		index2 = (length/2) + rand() % (length/2);
		tmp = array[index1];
		array[index1] = array[index2];
		array[index2] = tmp;
	}
	time = clock() - time;
	printf("copy: %f seconds\n", ((float)time)/CLOCKS_PER_SEC);
	
	
	/*Point*/
	time = clock();
	for(int i = 0; i < swapcount; ++i)
	{
		index1 = rand() % (length/2);
		index2 = (length/2) + rand() % (length/2);
		tmpptr = ptrarray[index1];
		ptrarray[index1] = ptrarray[index2];
		ptrarray[index2] = tmpptr;
	}
	time = clock() - time;
	printf("point: %f seconds\n", ((float)time)/CLOCKS_PER_SEC);


	return 0;
}